routes/web.php
<?php

use App\Http\Controllers\Admin;
use App\Http\Controllers\AppointmentController;
use App\Http\Controllers\Auth\LoginController;
use App\Http\Controllers\AvailabilityController;
use App\Http\Controllers\CartController;
use App\Http\Controllers\WishlistController;
use App\Http\Controllers\FrontCategoryController;
use App\Http\Controllers\CategoryController;
use App\Http\Controllers\CommandeController;
use App\Http\Controllers\CommentController;
use App\Http\Controllers\Auth\PasswordController;
use App\Http\Controllers\ProductController;
use App\Http\Controllers\ProfilClientController;
use App\Http\Controllers\RecetteController;
use App\Http\Controllers\ClientController;
use App\Http\Controllers\ConseilController;
use App\Http\Controllers\DashboardController;
use App\Http\Controllers\RatingController;
use App\Http\Controllers\SettingController;
use App\Http\Controllers\GestionInformationController;
use App\Http\Controllers\FrontController;
use App\Models\User;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Route;
use Illuminate\Support\Facades\Mail;

Route::get('/', [\App\Http\Controllers\HomeController::class, 'index'])->name('welcome');
// Routes accessibles à tous les utilisateurs
Auth::routes(['reset' => true]);
Route::get('logout', [LoginController::class, 'logout'])->name('admin.logout');
Route::post('/logout', [LoginController::class, 'logout'])->name('logout');
//MAIL REST PASSWORD
Route::post('password/reset' , [\App\Http\Controllers\Auth\ResetPasswordController::class, 'resetPassword'])->name('password.update');
Route::get('/test-email', function () {
    Mail::raw('This is a test email', function ($message) {
        $message->to('recipient@example.com')
            ->subject('Test Email from Laravel');
    });

    return 'Test email sent.';
});
//

Route::get('/home', [App\Http\Controllers\HomeController::class, 'index'])->name('home');
Route::get('/nutritionnistes', [FrontController::class, 'nutritionnistes'])->name('front.nutritionnistes.index');
Route::get('/nutritionnistes/search', [FrontController::class, 'searchNutritionnistes'])->name('nutritionnistes.search');
Route::get('/recettes/search', 'App\Http\Controllers\FrontController@search')->name('recette.search');

//category recette
Route::get('/category/{slug}',[App\Http\Controllers\FrontCategoryController::class, 'index'])->name('category.recette');

//route wishlist
Route::get('/wishlist', [WishlistController::class, 'index'])->name('wishlist');
Route::post('/wishlist/add/{id}', [WishlistController::class, 'add'])->name('wishlist.add')->middleware('auth');
Route::delete('/supprimer/item/wishlist/{id}', [WishlistController::class, 'delete'])->name('wishlist.remove')->middleware('auth');

//route rating

Route::post('/products/{product}/rate', [RatingController::class, 'storeProductRating'])->name('products.rate');
Route::post('/nutritionists/rate', [RatingController::class, 'storeNutritionistRating'])->name('nutritionists.rate');

Route::get('/recette', [FrontController::class, 'recettes'])->name('front.recettes.index');
Route::get('/recettes/{id}', [FrontController::class, 'recettedetails'])->name('front.recettedetails.index');
Route::get('/conseils', [FrontController::class, 'conseil'])->name('conseils');
Route::get('/conseils/{id}', [FrontController::class, 'conseildetails'])->name('front.conseildetails.index');
Route::get('/conseils/search', [FrontController::class, 'searchConseils'])->name('conseils.search');

Route::post('/conseils/{id}/comment', [App\Http\Controllers\CommentController::class, 'createConseil'])->name('comment.create.conseil');
Route::get('/shop',[FrontController::class,'shop'])->name('shop');
Route::get('/shop/search', [FrontController::class, 'shop'])->name('shop.search');
Route::get('/shop/{id}',[FrontController::class,'shopdetails'])->name('shopdetails.index');

Route::post('ajout/commande',[CommandeController::class,'store'])->name('commande.store')->middleware('auth');
Route::get('caisse',[CommandeController::class,'index'])->name('front.caisse.index')->middleware('auth');
//route cart
Route::get('/cart',[CartController::class,'index'])->name('cart.index')->middleware('auth');
Route::post('/ajout-cart/{id}', [CartController::class, 'ajout'])->name('ajout.cart');
Route::get('/supprimer/item/cart/{id}',[CartController::class,'delete'])->name('supprimer.cart')->middleware('auth');
Route::post('/edit/{id}',[CartController::class,'update'])->name('modifier.cart')->middleware('auth');


Route::post('/appointment', [AppointmentController::class, 'create'])->name('appointment.store');
Route::resource('appointments', AppointmentController::class);
Route::get('/api/appointments', [AppointmentController::class, 'apiAppointments'])->name('api.appointments');
Route::get('/appointments/list', [AppointmentController::class, 'listAppointments'])->name('appointments.list');
Route::resource('availabilities', AvailabilityController::class);

Route::put('/nutritionnistes/{nutritionniste}/approve', [\App\Http\Controllers\NutritionnisteController::class, 'approve'])->name('nutritionnistes.approve');
Route::patch('/nutritionniste/approve', [\App\Http\Controllers\NutritionnisteController::class, 'nutritionniste'])->name('approve.nutritionniste');
Route::get('/apropos', [App\Http\Controllers\FrontController::class, 'apropos'])->name('apropos');
Route::post('/recettes/{id}/comment', [App\Http\Controllers\CommentController::class, 'create'])->name('comment.create');

Route::get('profile', [\App\Http\Controllers\ProfileController::class, 'edit'])->name('admin.profile.edit');
Route::patch('profile', [\App\Http\Controllers\ProfileController::class, 'update'])->name('admin.profile.update');
Route::patch('modifier/password', [\App\Http\Controllers\Auth\PasswordController::class, 'update'])->name('password.update');



    Route::get('user/account', [ProfilClientController::class, 'edit'])->name('client.account.edit');
    Route::patch('user/account/edit', [ProfilClientController::class, 'update'])->name('client.account.update');
    Route::patch('account/password', [ProfilClientController::class, 'updatePassword'])->name('password.update.account');

    //Route access admin
Route::prefix('admin')->middleware('auth','admin')->group(function () {
   //Route settings
    Route::get('/paramettre', [SettingController::class, 'index'])->name('settings.index');
    Route::put('/paramettre/{settings}', [SettingController::class, 'update'])->name('settings.update');
//Route auteurs
    Route::resource('nutritionniste', App\Http\Controllers\NutritionnisteController::class)->shallow();
    Route::resource('client', App\Http\Controllers\clientController::class)->shallow();
//Route categories
    Route::resource('/category', CategoryController::class)->except(['show']);
//Route produits
    Route::resource('/produit', ProductController::class);
    //Route commande-cote-admin
    Route::get('/commandes',[\App\Http\Controllers\CommandeController::class, 'Admin'])->name('commande.admin');
    Route::delete('/admin/commandes/{id}', [CommandeController::class, 'destroy'])->name('admin.commandes.destroy');
    Route::get('/commande/voir/{id}',[\App\Http\Controllers\CommandeController::class, 'show'])->name('commande.voir');
    Route::get('commandes/confirm/{id}', [CommandeController::class, 'confirm'])->name('admin.commandes.confirm');
    Route::get('commandes/annuler/{id}', [CommandeController::class, 'annuler'])->name('admin.commandes.annuler');

});

//Route admin-nutritionniste
Route::prefix('dashboard')->middleware(['auth', 'CheckRole:' . User::TYPE_SUPER_ADMIN . ',' . User::TYPE_NUTRITIONNISTE])->group(function () {
    Route::get('/acceuil', [DashboardController::class, 'index'])->name('admin.dashboard');
    Route::resource('conseil', App\Http\Controllers\ConseilController::class);
    // Route::resource('client', ClientController::class)->except(['show']);
    Route::resource('/recette', RecetteController::class);
//Route commentaires
    Route::get('/comment', [\App\Http\Controllers\CommentController::class,'index'])->name('comment.index');
    Route::put('/comment/update/{comment}',[CommentController::class,'update'])->name('comment.update');
    Route::put('/comment/debloque/{id}',[CommentController::class,'debloquer'])->name('comment.debloquer');

});

//Route Nuutritionniste
Route::prefix('nutritionniste')->middleware('auth','Nutritionniste')->group(function () {
    Route::resource('/compte', GestionInformationController::class);

});
// Routes pour les utilisateurs invités (non connectés)
Route::middleware('guest')->group(function () {

    Route::get('login', [LoginController::class, 'showLoginForm'])->name('login');
    Route::get('password/reset', [\App\Http\Controllers\Auth\ResetPasswordController::class, 'showReset'])->name('password.request');
    Route::post('login', [LoginController::class, 'login'])->name('admin.login.submit');
});

app/Http/Controllers/ClientController.php
<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;

use App\Http\Requests\User\CreateUserRequest;
use App\Http\Requests\User\UpdateUserRequest;
use App\Models\User;
use App\Repositories\UserRepository;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Hash;
use Illuminate\Support\Facades\Storage;
use Intervention\Image\Facades\Image;

class ClientController extends Controller
{
    public function __construct(UserRepository $userRepository)
    {
        $this->userRepository = $userRepository;
    }

    public function index()
    {
        $clients = User::all()->where('type', User::TYPE_CLIENT)->sortByDesc('created_at');

        return view('admin.client.index', compact('clients'));

    }

    public function show($id)
    {
        $client = $this->userRepository->find($id);

        return view('admin.client.show')->with('client', $client);
    }

    public function create()
    {
        return view('admin.client.create');
    }

    public function store(CreateUserRequest $request)
    {
        $data = $request->all();
        if ($request->hasFile('avatar')) {
            $avatar = $request->file('avatar');
            $profileImage = date('YmdHis') . "." . $avatar->getClientOriginalExtension();
            $avatar->storeAs('public/avatars', $profileImage);

            $data['avatar'] = $profileImage;
        }

        $this->userRepository->create($data);

        return redirect()->route('client.index')->with('success', 'Client ajouté avec succès');
    }

    public function edit($id)
    {
        $client = $this->userRepository->find($id);

        return view('admin.client.edit', compact('client'));
    }


    public function update(UpdateUserRequest $request, $id)
    {
        $data = $request->all();

        $client = $this->userRepository->find($id);

        $this->userRepository->update($data, $client->id);

        return redirect()->route('client.index')->with('success', 'Client modifié avec succès');
    }

    public function destroy($id)
    {
        $nclient = $this->userRepository->find($id);

        if (empty($client)) {
            return redirect(route('client.index')->with('Client not found'));
        }

        if ($this->userRepository->delete($client->id))
            return redirect(route('client.index')->with('success', 'Client supprimé avec succès'));

    }
}

resources/views/admin/client/create.blade.php
@extends('layouts.admin.app')
@section('title','création - client')
@section('dashboard-header')
    <div class="row align-items-center">
        <div class="col">
            <h3 class="page-title mt-5">
                Ajouter un client
            </h3>
        </div>
    </div>
@endsection
@section('dashboard-content')
    <div class="row">
        <div class="col-lg-12">
            <form action="{{ route('client.store') }}" method="POST" enctype="multipart/form-data">
                @csrf
                <input type="hidden" name="type" value="{{ \App\Models\User::TYPE_CLIENT }}">

                <!-- Avatar -->
                <div class="form-group">
                    <label for="file-input" style="text-align: -webkit-center;">
                        <img id="previewImg" src="{{ asset('admin/assets/img/default-user.png') }}"
                             style="width: 150px; height: 150px;border-radius: 100%;"/>
                    </label>
                    <input id="file-input" type="file" onchange="previewFile(this);" style="display: none;"
                           name="avatar" class="form-control" placeholder="photo">
                    @error('avatar')
                    <div class="alert alert-danger mt-1 mb-1">{{ $message }}</div>
                    @enderror
                </div>
                <div class="row formtype">
                    <div class="col-md-6">
                        <div class="form-group">
                            <label for="first_name">Nom</label>
                            <input
                                id="first_name"
                                class="form-control"
                                type="text"
                                name="first_name"
                                required
                            />
                            @error('first_name')
                            <div class="alert alert-danger mt-1 mb-1">{{ $message }}</div>
                            @enderror
                        </div>
                    </div>
                    <div class="col-md-6">
                        <div class="form-group">
                            <label for="last_name">Prénom</label>
                            <input
                                id="last_name"
                                class="form-control"
                                type="text"
                                name="last_name"
                                required
                            />
                            @error('last_name')
                            <div class="alert alert-danger mt-1 mb-1">{{ $message }}</div>
                            @enderror
                        </div>
                    </div>
                    <div class="col-md-6">
                        <div class="form-group">
                            <label for="email">Email</label>
                            <input
                                id="email"
                                class="form-control"
                                type="email"
                                name="email"
                                required
                            />
                            @error('email')
                            <div class="alert alert-danger mt-1 mb-1">{{ $message }}</div>
                            @enderror
                        </div>
                    </div>
                    <div class="col-md-6">
                        <div class="form-group">
                            <label for="password">Mot de passe</label>
                            <input
                                id="password"
                                class="form-control"
                                type="password"
                                name="password"
                                required
                            />
                            @error('password')
                            <div class="alert alert-danger mt-1 mb-1">{{ $message }}</div>
                            @enderror
                        </div>
                    </div>
                    <div class="col-md-6">
                        <div class="form-group">
                            <label for="address">Adresse</label>
                            <input
                                id="address"
                                class="form-control"
                                type="text"
                                name="address"
                                required
                            />
                            @error('address')
                            <div class="alert alert-danger mt-1 mb-1">{{ $message }}</div>
                            @enderror
                        </div>
                    </div>
                    <div class="col-md-6">
                        <div class="form-group">
                            <label for="phone">Téléphone</label>
                            <input
                                id="phone"
                                class="form-control"
                                type="text"
                                name="phone"
                            />
                            @error('phone')
                            <div class="alert alert-danger mt-1 mb-1">{{ $message }}</div>
                            @enderror
                        </div>
                    </div>
                    <div class="col-md-6">
                        <div class="form-group">
                            <label for="isActive">Activation</label>
                            <select class="form-control" id="isActive" name="isActive">
                                <option value="1">Activer</option>
                                <option value="0">Ne pas activer</option>
                            </select>
                        </div>
                    </div>
                </div>
                <button type="submit" class="btn btn-primary buttonedit1">
                    Enregistrer
                </button>
            </form>
        </div>
    </div>

@endsection

resources/views/admin/client/edit.blade.php
@extends('layouts.admin.app')

@section('title', 'Modification de client')

@section('dashboard-header')
    <div class="page-header">
        <div class="row align-items-center">
            <div class="col">
                <div class="mt-5">
                    <h4 class="card-title float-left mt-2">Modifier un client</h4>
                    <a href="{{ route('client.index') }}"
                       class="btn btn-primary float-right veiwbutton">Retour</a>
                </div>
            </div>
        </div>
    </div>
@endsection

@section('dashboard-content')
    <div class="row">
        <div class="col-sm-12">
            <div class="card card-table">
                <div class="card-body">
                    <form action="{{ route('client.update',['client' => $client]) }}"  method="POST">
                        @csrf
                        @method('PUT')
                        <div class="form-group">
                            <label for="name">Nom</label>
                            <input type="text" class="form-control @error('first_name') is-invalid @enderror" id="first_name"
                                   name="first_name" value="{{ old('first_name', $client->first_name) }}" required>
                            @error('name')
                            <span class="invalid-feedback" role="alert">
                                    <strong>{{ $message }}</strong>
                                </span>
                            @enderror
                        </div>
                        <div class="form-group">
                            <label for="name">prenom</label>
                            <input type="text" class="form-control @error('last_name') is-invalid @enderror" id="last_name"
                                   name="last_name" value="{{ old('last_name', $client->last_name) }}" required>
                            @error('prenom')
                            <span class="invalid-feedback" role="alert">
                                    <strong>{{ $message }}</strong>
                                </span>
                            @enderror
                        </div>
                        <div class="form-group">
                            <label for="name">email </label>
                            <input type="text" class="form-control @error('email') is-invalid @enderror" id="email"
                                   name="email" value="{{ old('email', $client->email) }}" required>
                            @error('email')
                            <span class="invalid-feedback" role="alert">
                                    <strong>{{ $message }}</strong>
                                </span>
                            @enderror
                        </div>
                        <div class="form-group">
                            <label for="name">password </label>
                            <input type="text" class="form-control @error('password') is-invalid @enderror"
                                   id="password" name="password"
                                   value="{{ old('password', $client->password) }}" required>
                            @error('password')
                            <span class="invalid-feedback" role="alert">
                                    <strong>{{ $message }}</strong>
                                </span>
                            @enderror
                        </div>
                        <div class="form-group">
                            <label for="name">adresse </label>
                            <input type="text" class="form-control @error('address') is-invalid @enderror" id="address"
                                   name="address" value="{{ old('address', $client->address) }}" required>
                            @error('adresse')
                            <span class="invalid-feedback" role="alert">
                                    <strong>{{ $message }}</strong>
                                </span>
                            @enderror
                        </div>
                        <div class="form-group">
                            <label for="name">telephone </label>
                            <input type="text" class="form-control @error('telephone') is-invalid @enderror"
                                   id="telephone" name="phone"
                                   value="{{ old('phone', $client->phone) }}" required>
                            @error('telephone')
                            <span class="invalid-feedback" role="alert">
                                    <strong>{{ $message }}</strong>
                                </span>
                            @enderror
                        </div>


                        <div class="form-group">
                            <label for="isActive">Statut</label>
                            <select class="form-control @error('isActive') is-invalid @enderror" id="isActive"
                                    name="isActive">
                                <option
                                    value="1" {{ old('isActive', $client->isActive) == 1 ? 'selected' : '' }}>
                                    Activer
                                </option>
                                <option
                                    value="0" {{ old('isActive', $client->isActive) == 0 ? 'selected' : '' }}>
                                    Désactiver
                                </option>
                            </select>
                            @error('isActive')
                            <span class="invalid-feedback" role="alert">
                                    <strong>{{ $message }}</strong>
                                </span>
                            @enderror
                        </div>
                        <button type="submit" class="btn btn-primary">Enregistrer</button>
                    </form>
                </div>
            </div>
        </div>
    </div>
@endsection

resources/views/admin/client/index.blade.php
@extends('layouts.admin.app')
@section('title', 'Dashboard - client')
@section('dashboard-header')
    <div class="page-header">
        <div class="row align-items-center">
            <div class="col">
                <div class="mt-5">
                    <h4 class="card-title float-left mt-2">Client</h4>
                    <a href="{{ route('client.create') }}" class="btn btn-primary float-right veiwbutton">
                        Ajouter un client</a>

                </div>
            </div>
        </div>
    </div>
@endsection
@section('dashboard-content')
    <div class="row">
        <div class="col-sm-12">
            <div class="card card-table">
                <div class="card-body booking_card">
                    <div class="table-responsive">
                        <table class="datatable table table-stripped table table-hover table-center mb-0">
                            <thead>
                            <tr>
                                <th>Image</th>
                                <th>Nom</th>
                                <th>prenom</th>
                                <th>email</th>
                                <th>adresse</th>
                                <th>telephone</th>
                                <th>status</th>
                                <th class="text-right">Actions</th>
                            </tr>
                            </thead>
                            <tbody>
                            @foreach($clients as $client)
                                <tr>
                                    <td><img src="{{ asset($client->avatar) }}" alt="Avatar du client" alt= width="100" height="100"></td>
                                    <td>{{ $client->first_name }}</td>
                                    <td>{{ $client->last_name }}</td>
                                    <td>{{ $client->email }}</td>
                                    <td>{{ $client->address }}</td>
                                    <td>{{ $client->phone }}</td>
                                    <td class="text-center">
                                            <span class="badge badge-pill bg-success inv-badge">
                                                {{ $client->isActive == 1 ? "ACTIVE" : "DÉSACTIVÉ" }}
                                            </span>
                                    </td>
                                    <td class="text-right">
                                        <div class="dropdown dropdown-action">
                                            <a href="#" class="action-icon dropdown-toggle" data-toggle="dropdown" aria-expanded="false">
                                                <i class="fas fa-ellipsis-v ellipse_color"></i>
                                            </a>

                                            <div class="dropdown-menu dropdown-menu-right">
                                                <a class="dropdown-item" href="{{ route('client.show', $client->id) }}">
                                                    <i class="fas fa-pencil-alt m-r-5"></i> voir
                                                </a>
                                                <a class="dropdown-item" href="{{ route('client.edit', $client->id) }}">
                                                    <i class="fas fa-pencil-alt m-r-5"></i> Modifier
                                                </a>
                                                <a class="dropdown-item" href="#" data-toggle="modal" data-target="#delete_category_{{ $client->id }}">
                                                    <button type="submit" class="btn btn-danger">
                                                        <i class="fas fa-trash-alt m-r-5"></i> Supprimer
                                                    </button>
                                                </a>
                                            </div>
                                        </div>
                                    </td>
                                </tr>
                                <div id="delete_category_{{ $client->id }}" class="modal fade delete-modal" role="dialog">
                                    <div class="modal-dialog modal-dialog-centered">
                                        <div class="modal-content">
                                            <div class="modal-body text-center">
                                                <img src=" {{asset('admin/assets/img/sent.png')}}" alt="" width="50" height="46" />
                                                <h3 class="delete_class">
                                                    Êtes-vous sûr de vouloir supprimer ce client ?
                                                </h3>
                                                <div class="m-t-20">
                                                    <form action="{{ route('client.destroy', $client) }}" method="POST">
                                                        @csrf
                                                        @method('delete')
                                                        <button type="submit" class="btn btn-danger">Supprimer</button>
                                                        <button type="button" class="btn btn-white" data-dismiss="modal">Fermer</button>
                                                    </form>
                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                </div>
                            @endforeach
                            </tbody>
                        </table>
                    </div>
                </div>
            </div>
        </div>
    </div>
@endsection